if(!isPackage(CheckpointPackage) && $AddOn__Brick_Checkpoint == 1)
{
	forceRequiredAddOn("Brick_Checkpoint");
}
package PersonalSpawns
{
	function GameConnection::getSpawnPoint(%client)
	{
		if($AddOn__Brick_Checkpoint == 1 && isObject(%client.checkPointBrick))
		{
			%pos = %client.checkPointBrick.getSpawnPoint();
			%client.checkPointBrick.schedule(33,"spawnClient",%client);
			return %pos;
		} else {
			%bg = getBrickgroupFromObject(%client);
			%mini = getminigamefromobject(%client);
			%count = %bg.personalSpawns;
			%pos = Parent::getSpawnPoint(%client);

			if(isObject(%mini))
			{
				if(!%mini.useSpawnBricks)
				{
					return %pos;
				}
				if(%mini.useAllPlayersBricks)
				{
					if(%count > 0)
					{
						%i = getRandom(0,%count - 1);
						%br = %bg.personalSpawn[%i];
						if(!isObject(%br) || %br.getDatablock() != brickPersonalSpawnData.getID())
							return %pos;
						
						%br.schedule(33,"spawnClient",%client);
						return %br.getSpawnPoint();
					} else {
						%down = containerFindFirst($TypeMasks::fxBrickAlwaysObjectType,%pos,0.25,0.25,0.25);
						if(isObject(%down) && %down.getDatablock() == brickSpawnPointData.getID())
						{
							%down.schedule(33,"spawnClient",%client);
						}
						return %pos;
					}
				} else {
					%down = containerFindFirst($TypeMasks::fxBrickAlwaysObjectType,%pos,0.25,0.25,0.25);
					if(isObject(%down) && %down.getDatablock() == brickSpawnPointData.getID() && getBrickgroupFromObject(%down).client == %mini.owner)
					{
						%down.schedule(33,"spawnClient",%client);
					}
					return %pos;
				}
			} else {
				if(%count > 0)
				{
					%i = getRandom(0,%count - 1);
					%br = %bg.personalSpawn[%i];
					if(!isObject(%br) || %br.getDatablock() != brickPersonalSpawnData.getID())
						return %pos;
					
					%br.schedule(33,"spawnClient",%client);
					return %br.getSpawnPoint();
				} else {
					%down = containerFindFirst($TypeMasks::fxBrickAlwaysObjectType,%pos,0.25,0.25,0.25);
					if(isObject(%down) && %down.getDatablock() == brickSpawnPointData.getID())
					{
						%down.schedule(33,"spawnClient",%client);
					}
					return %pos;
				}
			}
		}
	}
	function brickPersonalSpawnData::onPlant(%data,%brick)
	{
		Parent::onPlant(%brick);
		%br = getBrickgroupFromObject(%brick);
		if(!isObject(%br))
			return;

		if(%br.personalSpawns $= "")
			%br.personalSpawns = 0;

		%br.personalSpawn[%br.personalSpawns] = %brick.getID();
		%br.personalSpawns++;
	}
	function brickPersonalSpawnData::onLoadPlant(%data,%brick)
	{
		Parent::onLoadPlant(%brick);
		%data.onPlant(%brick);
	}
	function brickPersonalSpawnData::onRemove(%data,%brick)
	{
		Parent::onRemove(%data,%brick);
		%br = getBrickgroupFromObject(%brick);
		if(!isObject(%br) || %br.personalSpawns <= 0)
			return;

		%id = %brick.getID();
		for(%i=0;%i<%br.personalSpawns;%i++)
		{
			if(%br.personalSpawn[%i] == %id)
			{
				%x = 1;
			}
			if(%x)
			{
				%br.personalSpawn[%i] = %br.personalSpawn[%i + 1];
			}
		}
		if(%x)
			%br.personalSpawns--;
	}
};
if(isPackage(CheckpointPackage))
{
	deactivatePackage(CheckpointPackage);
	// This emulates and enhances checkpoint bricks functionality if this
	// package exists, so it does not need to be enabled.
}
activatePackage(PersonalSpawns);

datablock fxDTSBrickData(brickPersonalSpawnData : brickSpawnPointData)
{
	uiName = "Personal Spawnpoint";
};

function fxDTSbrick::spawnClient(%brick,%client)
{
	if(isObject(%client.player) && vectorDist(%brick.getPosition(),%client.player.getPosition()) < 5)
	{
		$InputTarget_Self = %brick;
		$InputTarget_Player = %client.player;
		$InputTarget_Client = %client;
		$InputTarget_Minigame = (getMinigameFromObject(%client) $= getMinigameFromObject(%brick) ? getMinigameFromObject(%client) : "");
		%brick.processInputEvent("onSpawnPlayer",%client);
	}
}
registerInputEvent("fxDTSbrick","onSpawnPlayer","Self fxDTSbrick\tPlayer Player\tClient GameConnection\tMinigame MiniGame",1);